#include "config.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/param.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#ifndef _alc_h
#define _alc_h

#ifdef __cplusplus
#define LINKAGE "C"
#else
#define LINKAGE
#endif

/* size of the board */
#define ROWS 11
#define COLS 15

extern void goodsrandom(int);
extern int goodrandom(int);

enum { SAY_CANT, SAY_CRUNCH, SAY_EXPLODE, SAY_HYPERIN, SAY_HYPEROUT, SAY_WIN };
extern void say(int msg);

#define NAME_LENGTH	80
#define LOGIN_LENGTH	20

typedef struct s_player {
	char name[NAME_LENGTH];
  	char login[LOGIN_LENGTH];
  	char machine[MAXHOSTNAMELEN];
  	char domain[NAME_LENGTH];
  	int fd;				/* For player to player comm. */
	char has_first_move;		/* Only for player 0 */
} PLAYER;

typedef struct {
  Pixel   player1Color;
  Pixel   player2Color;
  String  defaultFile;
  Boolean debug;
  Boolean setup;
  String  soundCmd;
  String  cantSound;
  String  crunchSound;
  String  hyperinSound;
  String  hyperoutSound;
  String  winSound;
  String  explodeSound;
  int     port;
  String  name;
  String  helpFile;
} AppData, *AppDataPtr;

extern AppData appData;

extern XtAppContext app_con;
extern struct AlcBoard *board;
extern int comm;

extern PLAYER players[2];
extern XtInputId EnemyID;

extern LINKAGE void setup_communication(char *,char *,char *);
extern void EnemyInterrupt(XtPointer client_data, int *source, XtInputId *id);
extern void quit();

extern void send_select(int x, int y);
extern void send_rotate();
extern void send_fire();
extern void send_next_turn();
extern void send_srand(int s);
extern void send_quit();
extern void send_undo();

#define message printf

#undef LINKAGE
#endif /* _alc_h */






