/* AlcBoard Private header file */

/* Copyright 1990, David Nedde   (XawDrawingAreaWidget on which this is based)
/* Copyright 1994, Ziga Kranjec
/*
/* Permission to use, copy, modify, and distribute this
/* software and its documentation for any purpose and without fee
/* is granted provided that the above copyright notice appears in all copies.
/* It is provided "as is" without express or implied warranty.
*/

#ifndef _AlcBoardP_h
#define _AlcBoardP_h

#include "alcboard.h"
#ifdef X11_R3
#include <X11/SimpleP.h>
#else
#include <X11/Xaw/SimpleP.h>
#endif
#include <X11/xpm.h>

#include <stdlib.h>

/* The drawing area's contribution to the class record */
typedef struct _AlcBoardClassPart {
  int dummy;
} AlcBoardClassPart;

/* ALC board's full class record */
typedef struct _AlcBoardClassRec {
    CoreClassPart	core_class;
    SimpleClassPart	simple_class;
    AlcBoardClassPart   alcboard_class;
} AlcBoardClassRec;

extern AlcBoardClassRec alcBoardClassRec;

typedef struct _AlcBoardIcon {
  Pixmap pix;
  Pixmap mask;
} AlcBoardIcon;

/* Resources added and status of drawing area widget */
typedef struct _XsAlcBoardPart {
  /* Resources */
  Dimension             boardWidth;
  Dimension             boardHeight;
  Dimension             squareSize;
  Dimension             squareBorderWidth;
  Pixel                 squareBorderColor;
  Pixel                 darkBackground;
  Pixel                 lightBackground;
  Pixel                 selectBackground;
  Pixel                 holeBackground;
  Pixel                 frozenColor;
  Pixel                 laserColor;
  Dimension             laserThickness;
  String                iconFile;
  XtCallbackList	expose_callback;
  XtCallbackList	input_callback;
  XtCallbackList	motion_callback;
  XtCallbackList	resize_callback;
  XtCallbackList	select_callback;
  XtCallbackList	adjust_callback;
  /* other */
  int                   *square;
  XpmAttributes         iconPixmapAttr;
  int                   nicons;
  AlcBoardIcon          *icons;
  int                   x0,y0;       /* top left corner of board */
  int                   selx,sely;   /* selected square */
  GC                    blitgc;
  GC                    lightgc;
  GC                    darkgc;
  GC                    squarebordergc;
  GC                    lasergc;
} AlcBoardPart;


/* Drawing area's instance record */
typedef struct _AlcBoardRec {
    CorePart         core;
    SimplePart	     simple;
    AlcBoardPart     board;
} AlcBoardRec;

/* fireworks parameters */
#define ALC_FIREWORKS_POINTS 100
#define ALC_FIREWORKS_STEPS 150

#endif /* _AlcBoardP_h */

